searchData={"items":[{"type":"module","title":"aws_credentials","doc":"This is the main interface to the library. It provides a function get_credentials/0 which should return Credentials :: map() or undefined . If undefined, it will attempt to get credentials again after 5 seconds delay.","ref":"aws_credentials.html"},{"type":"function","title":"aws_credentials.code_change/3","doc":null,"ref":"aws_credentials.html#code_change/3"},{"type":"function","title":"aws_credentials.force_credentials_refresh/0","doc":"Force a credentials update (using the application environment options if any).","ref":"aws_credentials.html#force_credentials_refresh/0"},{"type":"function","title":"aws_credentials.force_credentials_refresh/1","doc":"Force a credentials update, passing options (which possibly override the options set in the erlang environment.)","ref":"aws_credentials.html#force_credentials_refresh/1"},{"type":"function","title":"aws_credentials.format_status/1","doc":null,"ref":"aws_credentials.html#format_status/1"},{"type":"function","title":"aws_credentials.format_status/2","doc":null,"ref":"aws_credentials.html#format_status/2"},{"type":"function","title":"aws_credentials.get_credentials/0","doc":"Get cached credential information.","ref":"aws_credentials.html#get_credentials/0"},{"type":"function","title":"aws_credentials.handle_call/3","doc":null,"ref":"aws_credentials.html#handle_call/3"},{"type":"function","title":"aws_credentials.handle_cast/2","doc":null,"ref":"aws_credentials.html#handle_cast/2"},{"type":"function","title":"aws_credentials.handle_info/2","doc":null,"ref":"aws_credentials.html#handle_info/2"},{"type":"function","title":"aws_credentials.init/1","doc":null,"ref":"aws_credentials.html#init/1"},{"type":"function","title":"aws_credentials.make_map/3","doc":null,"ref":"aws_credentials.html#make_map/3"},{"type":"function","title":"aws_credentials.make_map/4","doc":null,"ref":"aws_credentials.html#make_map/4"},{"type":"function","title":"aws_credentials.make_map/5","doc":null,"ref":"aws_credentials.html#make_map/5"},{"type":"function","title":"aws_credentials.start_link/0","doc":"Start the server that stores and automatically updates client credentials fetched from the instance metadata service.","ref":"aws_credentials.html#start_link/0"},{"type":"function","title":"aws_credentials.stop/0","doc":"Stop the server that holds the credentials.","ref":"aws_credentials.html#stop/0"},{"type":"function","title":"aws_credentials.terminate/2","doc":null,"ref":"aws_credentials.html#terminate/2"},{"type":"type","title":"aws_credentials.access_key_id/0","doc":null,"ref":"aws_credentials.html#t:access_key_id/0"},{"type":"type","title":"aws_credentials.credentials/0","doc":null,"ref":"aws_credentials.html#t:credentials/0"},{"type":"type","title":"aws_credentials.region/0","doc":null,"ref":"aws_credentials.html#t:region/0"},{"type":"type","title":"aws_credentials.secret_access_key/0","doc":null,"ref":"aws_credentials.html#t:secret_access_key/0"},{"type":"opaque","title":"aws_credentials.state/0","doc":null,"ref":"aws_credentials.html#t:state/0"},{"type":"type","title":"aws_credentials.token/0","doc":null,"ref":"aws_credentials.html#t:token/0"},{"type":"module","title":"aws_credentials_app","doc":null,"ref":"aws_credentials_app.html"},{"type":"function","title":"aws_credentials_app.start/2","doc":null,"ref":"aws_credentials_app.html#start/2"},{"type":"function","title":"aws_credentials_app.stop/1","doc":null,"ref":"aws_credentials_app.html#stop/1"},{"type":"module","title":"aws_credentials_ec2","doc":"This provider looks up credential information from EC2 metadata.","ref":"aws_credentials_ec2.html"},{"type":"function","title":"aws_credentials_ec2.fetch/1","doc":null,"ref":"aws_credentials_ec2.html#fetch/1"},{"type":"type","title":"aws_credentials_ec2.field/0","doc":null,"ref":"aws_credentials_ec2.html#t:field/0"},{"type":"type","title":"aws_credentials_ec2.not200/1","doc":null,"ref":"aws_credentials_ec2.html#t:not200/1"},{"type":"type","title":"aws_credentials_ec2.request_header/0","doc":null,"ref":"aws_credentials_ec2.html#t:request_header/0"},{"type":"type","title":"aws_credentials_ec2.request_headers/0","doc":null,"ref":"aws_credentials_ec2.html#t:request_headers/0"},{"type":"type","title":"aws_credentials_ec2.role/0","doc":null,"ref":"aws_credentials_ec2.html#t:role/0"},{"type":"type","title":"aws_credentials_ec2.session_token/0","doc":null,"ref":"aws_credentials_ec2.html#t:session_token/0"},{"type":"type","title":"aws_credentials_ec2.value/0","doc":null,"ref":"aws_credentials_ec2.html#t:value/0"},{"type":"module","title":"aws_credentials_ecs","doc":"Implements a provider which fetches credentials from an ECS task. There are currently no options or environment variables. @end","ref":"aws_credentials_ecs.html"},{"type":"function","title":"aws_credentials_ecs.fetch/1","doc":null,"ref":"aws_credentials_ecs.html#fetch/1"},{"type":"module","title":"aws_credentials_env","doc":"This provider checks the Erlang environment and OS environment variables for AWS credentials. The following names can be used: (They are case sensitive) AWS_ACCESS_KEY_ID AWS_SECRET_ACCESS_KEY AWS_SESSION_TOKEN AWS_SECURITY_TOKEN AWS_DEFAULT_REGION AWS_REGION At a minimum, the access key and secret keys must be defined. If used in an Erlang context, these environment variable names should be strings. (I.e., is_list(EnvName) returns true ).","ref":"aws_credentials_env.html"},{"type":"function","title":"aws_credentials_env.fetch/1","doc":null,"ref":"aws_credentials_env.html#fetch/1"},{"type":"module","title":"aws_credentials_file","doc":"This provider reads the credentials and config files for the Amazon CLI tools. This format is documented here but an example might look like: ~/.aws/credentials [ default ] aws_access_key_id = AKIAIOSFODNN7EXAMPLE aws_secret_access_key = wJalrXUtnFEMI / K7MDENG / bPxRfiCYEXAMPLEKEY aws_session_token = wJalrXUtnFEMI / K7MDENG / bPxRfiCYEXAMPLETOKEN ~/.aws/config [ default ] region = us - east - 1 Environment parameters: &lt;&lt;&quot;credentials_path&quot;&gt;&gt; - this is the base path to the both CLI configuration files. And based on this path, credentials file should exist and config file is optional. By default this is ~/.aws/ &lt;&lt;&quot;profile&quot;&gt;&gt; - this is the desired profile to use in the credentials file. By default this is &lt;&lt;&quot;default&quot;&gt;&gt;","ref":"aws_credentials_file.html"},{"type":"function","title":"aws_credentials_file.fetch/1","doc":null,"ref":"aws_credentials_file.html#fetch/1"},{"type":"module","title":"aws_credentials_httpc","doc":"This implements an http client using the Erlang built in http client. If desired, this could be abstracted to support arbitrary http clients that return {ok, Status :: non_neg_integer(), Body :: binary(), Headers :: map()} or {error, Reasons :: [term()]} . On errors, there will be a number of attempts with a delay equal to 100 milliseconds times the number of tries minus tries left. (So the first delay would be 100 milliseconds. The second delay would be 200 milliseconds, and so on...)","ref":"aws_credentials_httpc.html"},{"type":"function","title":"aws_credentials_httpc.request/2","doc":"Attempt to request a URL with the 3 retries. 3 is the default.","ref":"aws_credentials_httpc.html#request/2"},{"type":"function","title":"aws_credentials_httpc.request/3","doc":null,"ref":"aws_credentials_httpc.html#request/3"},{"type":"function","title":"aws_credentials_httpc.request/4","doc":"Attempt to request a URL with a specified positive number of retries. (Minimum of 1.) Note this function may return {ok, Results} even if it was unable to successfully get the desired data. That is, it will return an ok tuple with a status code of 500 or 404 or some other HTTP error code and no data.","ref":"aws_credentials_httpc.html#request/4"},{"type":"function","title":"aws_credentials_httpc.start/0","doc":null,"ref":"aws_credentials_httpc.html#start/0"},{"type":"type","title":"aws_credentials_httpc.body/0","doc":null,"ref":"aws_credentials_httpc.html#t:body/0"},{"type":"type","title":"aws_credentials_httpc.header/0","doc":null,"ref":"aws_credentials_httpc.html#t:header/0"},{"type":"type","title":"aws_credentials_httpc.headers/0","doc":null,"ref":"aws_credentials_httpc.html#t:headers/0"},{"type":"type","title":"aws_credentials_httpc.http_version/0","doc":null,"ref":"aws_credentials_httpc.html#t:http_version/0"},{"type":"type","title":"aws_credentials_httpc.httpc_result/0","doc":null,"ref":"aws_credentials_httpc.html#t:httpc_result/0"},{"type":"type","title":"aws_credentials_httpc.method/0","doc":null,"ref":"aws_credentials_httpc.html#t:method/0"},{"type":"type","title":"aws_credentials_httpc.reason_phrase/0","doc":null,"ref":"aws_credentials_httpc.html#t:reason_phrase/0"},{"type":"type","title":"aws_credentials_httpc.response/0","doc":null,"ref":"aws_credentials_httpc.html#t:response/0"},{"type":"type","title":"aws_credentials_httpc.response_error/0","doc":null,"ref":"aws_credentials_httpc.html#t:response_error/0"},{"type":"type","title":"aws_credentials_httpc.status_code/0","doc":null,"ref":"aws_credentials_httpc.html#t:status_code/0"},{"type":"type","title":"aws_credentials_httpc.status_line/0","doc":null,"ref":"aws_credentials_httpc.html#t:status_line/0"},{"type":"type","title":"aws_credentials_httpc.url/0","doc":null,"ref":"aws_credentials_httpc.html#t:url/0"},{"type":"behaviour","title":"aws_credentials_provider","doc":"This is the behaviour definition for a credential provider module and it iterates over a list of providers. You may set the credential_providers` Erlang environment variable if you want to restrict checking only a certain subset of the default list or if you want to use your own custom providers. Default order of checking for credentials is: &lt;ol&gt; &lt;li&gt;Erlang application environment&lt;/li&gt; &lt;li&gt;OS environment&lt;/li&gt; &lt;li&gt;Credentials from AWS file&lt;/li&gt; &lt;li&gt;ECS Task credentials&lt;/li&gt; &lt;li&gt;EC2 credentials&lt;/li&gt; &lt;/ol&gt; Providers are expected to implement a function called `fetch/1 which takes as its argument a proplist of options which may influence the operation of the provider. The fetch/1 function should return either {ok, Credentials, Expiration} or {error, Reason} . If a provider returns {ok, ...} then evaluation stops at that provider. If it returns {error, ...} then the next provider is executed in order until either a set of credentials are returned or the tuple {error, no_credentials} is returned. If a new provider is desired, the behaviour interface should be implemented and its module name added to the default list.","ref":"aws_credentials_provider.html"},{"type":"function","title":"aws_credentials_provider.fetch/0","doc":null,"ref":"aws_credentials_provider.html#fetch/0"},{"type":"function","title":"aws_credentials_provider.fetch/1","doc":null,"ref":"aws_credentials_provider.html#fetch/1"},{"type":"callback","title":"aws_credentials_provider.fetch/1","doc":null,"ref":"aws_credentials_provider.html#c:fetch/1"},{"type":"type","title":"aws_credentials_provider.error_log/0","doc":null,"ref":"aws_credentials_provider.html#t:error_log/0"},{"type":"type","title":"aws_credentials_provider.expiration/0","doc":null,"ref":"aws_credentials_provider.html#t:expiration/0"},{"type":"type","title":"aws_credentials_provider.options/0","doc":null,"ref":"aws_credentials_provider.html#t:options/0"},{"type":"type","title":"aws_credentials_provider.provider/0","doc":null,"ref":"aws_credentials_provider.html#t:provider/0"},{"type":"module","title":"aws_credentials_sup","doc":null,"ref":"aws_credentials_sup.html"},{"type":"function","title":"aws_credentials_sup.init/1","doc":null,"ref":"aws_credentials_sup.html#init/1"},{"type":"function","title":"aws_credentials_sup.start_link/0","doc":null,"ref":"aws_credentials_sup.html#start_link/0"},{"type":"extras","title":"Overview","doc":"aws_credentials\n===============\n\n[![Actions Status](https://github.com/aws-beam/aws_credentials/workflows/Build/badge.svg)](https://github.com/aws-beam/aws_credentials/actions)\n\nThis is a library to retrieve AWS credentials from a variety of possible\nsources in the following default order:\n\n1. Erlang application environment variables\n2. OS environment variables\n3. An AWS [credentials file][1]\n4. ECS task credentials\n5. EC2 metadata\n\nUsage\n-----\nInclude the library in your rebar.config file, and then...\n\n```erlang\n{ok, _} = application:ensure_all_started(aws_credentials),\nCredentials = aws_credentials:get_credentials().\n```\n\nCredentials is either `undefined`, if no credentials are available,\nor a map of the shape:\n\n```erlang\n#{\n  provider_source => Provider :: module(),\n  access_key_id => AccessKey :: binary(),\n  secret_access_key => SecretKey :: binary(),\n  token => Token :: binary(),\n  region => Region :: binary()\n}\n```\n\nNot all providers will populate all map keys.\n\nIf no credentials are found, the library will attempt to fetch them\nagain in 5 seconds. If you'd prefer for the application to not boot at all\nwithout credentials, you can set `fail_if_unavailable` environment variable\nfor `aws_credentials` to true.\n\nIt is best practice to **not** cache these credentials inside of your own\napplication. Always use the aws_credentials library to retrieve them - this way\nyou will always get \"fresh\" credentials from the internal state of the\napplication.\n\nDependencies\n------------\nThis library depends on the following libraries:\n\n* [iso8601][2]\n* [jsx][6]\n* [eini][3]\n\nImplementation\n--------------\nEach possible location for credentials is an Erlang module which implements the\n[aws_credentials_provider][4] behaviour.  The first provider to respond with\n(apparently) valid credentials stops evaluation of later providers.\n\n#","ref":"readme.html"},{"type":"extras","title":"Adding a new provider ### - Overview","doc":"If you want to add a new provider, you simply implement the behaviour and add\nthe module name to the default list of modules to attempt.\n\n#","ref":"readme.html#adding-a-new-provider"},{"type":"extras","title":"Provider return values ### - Overview","doc":"Providers are expected to return either `{error, Reason :: term()}` or\n`{ok, Credentials :: map(), Expiration :: infinity | binary() | pos_integer()}`.\n\nThe expiration time from a provider can either be expressed as:\n* the atom `infinity`,\n* epoch seconds as an integer, or,\n* as an ISO8601 time/date string (e.g., \"2019-03-14T23:45:56Z\").\n\nIf you specify the expiration as `infinity` the library will *never* attempt to\nrefresh credentials.\n\nWhen credentials have been found, they will be cached in a gen_server until the\ncredential's expiration time. 5 minutes before expiration time the gen_server\nwill attempt to acquire new credentials, so credentials will automatically be\nrefreshed in the background.\n\n#","ref":"readme.html#provider-return-values"},{"type":"extras","title":"Choosing certain credentials providers ### - Overview","doc":"If you want to change the order of providers used to retrieve credentials, you\ncan change the list of modules in your erlang environment variables as in\nthis example:\n\n```erlang\n{aws_credentials, [{credential_providers, [aws_credentials_ecs]}]}.\n```\n\nDifferent credential providers may have other settings which you can use to\nchange their behaviors.  See the documentation for each provider for more\ndetails.\n\nLicense and copyright\n---------------------\nThis project is licensed under the terms of the Apache 2 license. It is a\nheavily modified fork of the original [aws-erlang-metadata][5] project.\n\nCopyright (C) 2018 by Mark R. Allen.\n\n[1]: https://docs.aws.amazon.com/cli/latest/userguide/cli-config-files.html\n[2]: https://github.com/erlsci/iso8601\n[3]: https://github.com/aws-beam/eini\n[4]: src/aws_credentials_provider.erl\n[5]: https://github.com/aws-beam/aws-erlang-metadata\n[6]: https://github.com/talentdeficit/jsx","ref":"readme.html#choosing-certain-credentials-providers"},{"type":"extras","title":"License","doc":"Copyright (c) 2015, Jamu Kakar  , Liz  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html"}],"content_type":"text/plain"}